/*
 *	Copyright (C) 2022 Jan Bobrowski <jb@torinak.com>
 *
 *	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	version 2 as published by the Free Software Foundation.
 */

#include <stdlib.h>
#include <libdeflate.h>
#include "ttf2woff.h"

char *copression_by = "libdeflate";

int zlib_compress(struct buf *out, struct buf inp)
{
	struct libdeflate_compressor *z = libdeflate_alloc_compressor(12);
	size_t v;
	int ret = 0;

	v = libdeflate_zlib_compress(z, inp.ptr, inp.len, out->ptr, out->len);
	if (v) {
		out->len = v;
		ret = 1;
	}

	libdeflate_free_compressor(z);
	return ret;
}

void zlib_decompress(struct buf out, struct buf inp)
{
	struct libdeflate_decompressor *z = libdeflate_alloc_decompressor();
	enum libdeflate_result v = libdeflate_zlib_decompress(z, inp.ptr, inp.len, out.ptr, out.len, 0);

	if (v != LIBDEFLATE_SUCCESS)
		errx(1, "libdeflate decompression error");

	libdeflate_free_decompressor(z);
}
