/*
 *	Copyright (C) 2013, 2022 Jan Bobrowski <jb@torinak.com>
 *
 *	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	version 2 as published by the Free Software Foundation.
 */

#include <zlib.h>

#ifndef ZLIB_DECOMPRESS_ONLY
#include <stdlib.h>
#include "ttf2woff.h"

char *copression_by = "zlib";

int zlib_compress(struct buf *out, struct buf inp)
{
	uLongf len = out->len;
	int v = compress2(out->ptr, &len, inp.ptr, inp.len, 9);

	if(v == Z_OK) {
		out->len = len;
		return 1;
	} else {
		return 0;
	}
}
#endif

void zlib_decompress(struct buf out, struct buf inp)
{
	char *m;
	uLongf len = out.len;
	switch(uncompress(out.ptr, &len, inp.ptr, inp.len)) {
	case Z_OK:
		if(len == out.len)
			return;
	case Z_MEM_ERROR: m = "Bad uncompressed length"; break;
	case Z_DATA_ERROR: m = "Data corrupted"; ; break;
	default: m = "Error";
	}

	errx(3, "zlib: %s", m);
}
