/*
 *	Copyright (C) 2013-2017 Jan Bobrowski <jb@torinak.com>
 *
 *	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	version 2 as published by the Free Software Foundation.
 */

#include <string.h>
#include <stdlib.h>
#include "ttf2woff.h"

void read_ttf(struct ttf *ttf, u8 *data, size_t length, unsigned start)
{
	int i;
	u8 *p;

	if(length - start < 12 + 16)
		ERR_TRUNCATED;

	ttf->flavor = g32(data + start);
	ttf->ntables = g16(data + start + 4);

	if(!ttf->ntables)
		ERR_FONT;
	if(length - start <= 12 + 16*ttf->ntables)
		ERR_TRUNCATED;

	alloc_tables(ttf);

	p = data + start + 12;
	for(i = 0; i < ttf->ntables; i++) {
		struct table *t = &ttf->tables[i];
		u32 ofs = g32(p+8);
		u32 len = g32(p+12);
		if(!sum_in_range(ofs, len, length))
			ERR_FONT;
		t->tag = g32(p);
		t->csum = g32(p+4);
		t->pos = ofs;
		t->buf.ptr = data + ofs;
		t->buf.len = len;
		name_table(t);

		p += 16;
	}
}
